> For the complete documentation index, see [llms.txt](https://docs.indexcoop.com/index-coop-community-handbook/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.indexcoop.com/index-coop-community-handbook/protocol/index-protocol/core-contracts/controller.md).

# Controller

The Index Protocol **Controller** ([Etherscan](https://etherscan.io/address/0xd2463675a099101e36d85278494268261a66603a)) is a contract that registers system contracts such as added [setTokens](/index-coop-community-handbook/protocol/index-protocol/core-contracts/set-token.md), [Modules](/index-coop-community-handbook/protocol/index-protocol/modules.md), factories, resources (like [Price Oracles](/index-coop-community-handbook/protocol/index-protocol/core-contracts/price-oracle.md)), and protocol fee configurations.

## Select View Methods

### getModuleFee()

`function getModuleFee(address _moduleAddress, uint256 _feeType) external view returns (uint256)`

Returns the protocol fee for a given module.

| Parameter Name  | Type    | Description       |
| --------------- | ------- | ----------------- |
| \_moduleAddress | address | Address of module |
| \_feeType       | uint256 | Fee type          |

| Return Name | Type    | Description                   |
| ----------- | ------- | ----------------------------- |
| fee         | uint256 | Stored protocol fee on module |

### isSystemContract()

`function isSystemContract(address _contractAddress) external view returns (bool)`

Check if a contract address is a module, Set, resource, factory or controller.

| Parameter Name    | Type    | Description         |
| ----------------- | ------- | ------------------- |
| \_contractAddress | address | Address of contract |

| Return Name      | Type | Description                                           |
| ---------------- | ---- | ----------------------------------------------------- |
| isSystemContract | bool | Boolean that returns if address is part of Set system |


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.indexcoop.com/index-coop-community-handbook/protocol/index-protocol/core-contracts/controller.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
